Open CASCADE Technology: HLRBRep_PolyAlgo Class Reference

Open CASCADE Technology 6.8.0

- Main Page
- Related Pages
- Namespaces
- Data Structures
- Files

- Data Structures
- Data Structure Index
- Class Hierarchy
- Data Fields

Public Member Functions
HLRBRep_PolyAlgo Class Reference

to remove Hidden lines on Shapes with Triangulations. A framework to compute the shape as seen in a projection plane. This is done by calculating the visible and the hidden parts of the shape. HLRBRep_PolyAlgo works with three types of entity: More...

`#include <HLRBRep_PolyAlgo.hxx>`

Inheritance diagram for HLRBRep_PolyAlgo:
[legend]

## Public Member Functions
| HLRBRep_PolyAlgo ()
| Constructs an empty framework for the calculation of the visible and hidden lines of a shape in a projection. Use the functions: More...
| HLRBRep_PolyAlgo (const Handle< HLRBRep_PolyAlgo > &A)
| HLRBRep_PolyAlgo (const TopoDS_Shape &S)
Standard_Integer | NbShapes () const
TopoDS_Shape & | Shape (const Standard_Integer I)
void | Remove (const Standard_Integer I)
| remove the Shape of Index . More...
Standard_Integer | Index (const TopoDS_Shape &S) const
| return the index of the Shape <S> and return 0 if the Shape <S> is not found. More...
void | Load (const TopoDS_Shape &S)
| Loads the shape S into this framework. Warning S must have already been triangulated. More...
Handle< HLRAlgo_PolyAlgo > | Algo () const
const HLRAlgo_Projector & | Projector () const
| Sets the parameters of the view for this framework. These parameters are defined by an HLRAlgo_Projector object, which is returned by the Projector function on a Prs3d_Projector object. More...
void | Projector (const HLRAlgo_Projector &P)
Standard_Real | Angle () const
void | Angle (const Standard_Real Ang)
Standard_Real | TolAngular () const
void | TolAngular (const Standard_Real Tol)
Standard_Real | TolCoef () const
void | TolCoef (const Standard_Real Tol)
void | Update ()
| Launches calculation of outlines of the shape visualized by this framework. Used after setting the point of view and defining the shape or shapes to be visualized. More...
void | InitHide ()
Standard_Boolean | MoreHide () const
void | NextHide ()
void | Hide (Standard_Address &Coordinates, HLRAlgo_EdgeStatus &status, TopoDS_Shape &S, Standard_Boolean &reg1, Standard_Boolean &regn, Standard_Boolean &outl, Standard_Boolean &intl)
void | InitShow ()
Standard_Boolean | MoreShow () const
void | NextShow ()
void | Show (Standard_Address &Coordinates, TopoDS_Shape &S, Standard_Boolean &reg1, Standard_Boolean &regn, Standard_Boolean &outl, Standard_Boolean &intl)
TopoDS_Shape | OutLinedShape (const TopoDS_Shape &S) const
| Make a shape with the internal outlines in each face. More...
Standard_Boolean | Debug () const
void | Debug (const Standard_Boolean B)
Public Member Functions inherited from MMgt_TShared
virtual void | Delete () const
| Memory deallocator for transient classes. More...
Public Member Functions inherited from Standard_Transient
| Standard_Transient ()
| Empty constructor. More...
| Standard_Transient (const Standard_Transient &)
| Copy constructor – does nothing. More...
Standard_Transient & | operator= (const Standard_Transient &)
| Assignment operator, needed to avoid copying reference counter. More...
virtual | ~Standard_Transient ()
| Destructor must be virtual. More...
virtual const Handle_Standard_Type & | DynamicType () const
| Returns a type information object about this object. More...
Standard_Boolean | IsInstance (const Handle_Standard_Type &theType) const
| Returns a true value if this is an instance of Type. More...
Standard_Boolean | IsInstance (const Standard_CString theTypeName) const
| Returns a true value if this is an instance of TypeName. More...
Standard_Boolean | IsKind (const Handle_Standard_Type &theType) const
| Returns true if this is an instance of Type or an instance of any class that inherits from Type. Note that multiple inheritance is not supported by OCCT RTTI mechanism. More...
Standard_Boolean | IsKind (const Standard_CString theTypeName) const
| Returns true if this is an instance of TypeName or an instance of any class that inherits from TypeName. Note that multiple inheritance is not supported by OCCT RTTI mechanism. More...
virtual Handle_Standard_Transient | This () const
| Returns a Handle which references this object. Must never be called to objects created in stack. More...
Standard_Integer | GetRefCount () const
| Get the reference counter of this object. More...

## Detailed Description

to remove Hidden lines on Shapes with Triangulations. A framework to compute the shape as seen in a projection plane. This is done by calculating the visible and the hidden parts of the shape. HLRBRep_PolyAlgo works with three types of entity:

- shapes to be visualized (these shapes must have already been triangulated.)
- edges in these shapes (these edges are defined as polygonal lines on the triangulation of the shape, and are the basic entities which will be visualized or hidden), and
- triangles in these shapes which hide the edges. HLRBRep_PolyAlgo is based on the principle of comparing each edge of the shape to be visualized with each of the triangles produced by the triangulation of the shape, and calculating the visible and the hidden parts of each edge. For a given projection, HLRBRep_PolyAlgo calculates a set of lines characteristic of the object being represented. It is also used in conjunction with the HLRBRep_PolyHLRToShape extraction utilities, which reconstruct a new, simplified shape from a selection of calculation results. This new shape is made up of edges, which represent the shape visualized in the projection. HLRBRep_PolyAlgo works with a polyhedral simplification of the shape whereas HLRBRep_Algo takes the shape itself into account. When you use HLRBRep_Algo, you obtain an exact result, whereas, when you use HLRBRep_PolyAlgo, you reduce computation time but obtain polygonal segments. An HLRBRep_PolyAlgo object provides a framework for:
- defining the point of view
- identifying the shape or shapes to be visualized
- calculating the outlines
- calculating the visible and hidden lines of the shape. Warning
- Superimposed lines are not eliminated by this algorithm.
- There must be no unfinished objects inside the shape you wish to visualize.
- Points are not treated.
- Note that this is not the sort of algorithm used in generating shading, which calculates the visible and hidden parts of each face in a shape to be visualized by comparing each face in the shape with every other face in the same shape.

## Constructor & Destructor Documentation

HLRBRep_PolyAlgo::HLRBRep_PolyAlgo | ( |  | ) |

Constructs an empty framework for the calculation of the visible and hidden lines of a shape in a projection. Use the functions:

- Projector to define the point of view
- Load to select the shape or shapes to be visualized
- Update to compute the visible and hidden lines of the shape. Warning The shape or shapes to be visualized must have already been triangulated.

HLRBRep_PolyAlgo::HLRBRep_PolyAlgo | ( | const Handle< HLRBRep_PolyAlgo > & | A | ) |

HLRBRep_PolyAlgo::HLRBRep_PolyAlgo | ( | const TopoDS_Shape & | S | ) |

## Member Function Documentation

Handle< HLRAlgo_PolyAlgo > HLRBRep_PolyAlgo::Algo | ( |  | ) | const

Standard_Real HLRBRep_PolyAlgo::Angle | ( |  | ) | const

void HLRBRep_PolyAlgo::Angle | ( | const Standard_Real | Ang | ) |

Standard_Boolean HLRBRep_PolyAlgo::Debug | ( |  | ) | const

void HLRBRep_PolyAlgo::Debug | ( | const Standard_Boolean | B | ) |

void HLRBRep_PolyAlgo::Hide | ( | Standard_Address & | Coordinates,
|  | HLRAlgo_EdgeStatus & | status,
|  | TopoDS_Shape & | S,
|  | Standard_Boolean & | reg1,
|  | Standard_Boolean & | regn,
|  | Standard_Boolean & | outl,
|  | Standard_Boolean & | intl
| ) |  |

Standard_Integer HLRBRep_PolyAlgo::Index | ( | const TopoDS_Shape & | S | ) | const

return the index of the Shape <S> and return 0 if the Shape <S> is not found.

void HLRBRep_PolyAlgo::InitHide | ( |  | ) |

void HLRBRep_PolyAlgo::InitShow | ( |  | ) |

void HLRBRep_PolyAlgo::Load | ( | const TopoDS_Shape & | S | ) |

Loads the shape S into this framework. Warning S must have already been triangulated.

Standard_Boolean HLRBRep_PolyAlgo::MoreHide | ( |  | ) | const

Standard_Boolean HLRBRep_PolyAlgo::MoreShow | ( |  | ) | const

Standard_Integer HLRBRep_PolyAlgo::NbShapes | ( |  | ) | const

void HLRBRep_PolyAlgo::NextHide | ( |  | ) |

void HLRBRep_PolyAlgo::NextShow | ( |  | ) |

TopoDS_Shape HLRBRep_PolyAlgo::OutLinedShape | ( | const TopoDS_Shape & | S | ) | const

Make a shape with the internal outlines in each face.

const HLRAlgo_Projector& HLRBRep_PolyAlgo::Projector | ( |  | ) | const

Sets the parameters of the view for this framework. These parameters are defined by an HLRAlgo_Projector object, which is returned by the Projector function on a Prs3d_Projector object.

void HLRBRep_PolyAlgo::Projector | ( | const HLRAlgo_Projector & | P | ) |

void HLRBRep_PolyAlgo::Remove | ( | const Standard_Integer | I | ) |

remove the Shape of Index .

TopoDS_Shape& HLRBRep_PolyAlgo::Shape | ( | const Standard_Integer | I | ) |

void HLRBRep_PolyAlgo::Show | ( | Standard_Address & | Coordinates,
|  | TopoDS_Shape & | S,
|  | Standard_Boolean & | reg1,
|  | Standard_Boolean & | regn,
|  | Standard_Boolean & | outl,
|  | Standard_Boolean & | intl
| ) |  |

Standard_Real HLRBRep_PolyAlgo::TolAngular | ( |  | ) | const

void HLRBRep_PolyAlgo::TolAngular | ( | const Standard_Real | Tol | ) |

Standard_Real HLRBRep_PolyAlgo::TolCoef | ( |  | ) | const

void HLRBRep_PolyAlgo::TolCoef | ( | const Standard_Real | Tol | ) |

void HLRBRep_PolyAlgo::Update | ( |  | ) |

Launches calculation of outlines of the shape visualized by this framework. Used after setting the point of view and defining the shape or shapes to be visualized.

The documentation for this class was generated from the following file:

- HLRBRep_PolyAlgo.hxx